%global momorel 1

Name:           ikiwiki
Version:        2.53
Release:        %{momorel}m%{?dist}
Summary:        A wiki compiler

Group:          Applications/Internet
License:        GPLv2+
URL:            http://ikiwiki.info/
Source0:        http://ftp.debian.org/debian/pool/main/i/%{name}/%{name}_%{version}.tar.gz
NoSource:       0
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

BuildRequires:  perl(Text::Markdown)
BuildRequires:  perl(Mail::Sendmail)
BuildRequires:  perl(HTML::Scrubber)
BuildRequires:  perl(XML::Simple)
BuildRequires:  perl(Date::Parse)
BuildRequires:  perl(Date::Format)
BuildRequires:  perl(HTML::Template)
#BuildRequires:  perl(CGI::FormBuilder)
BuildRequires:  perl-CGI-FormBuilder
#BuildRequires:  perl(CGI::Session)
BuildRequires:  perl-CGI-Session
#BuildRequires:  perl(File::MimeInfo)
BuildRequires:  perl-File-MimeInfo
BuildRequires:  gettext

Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

Requires:       perl(Text::Markdown)
Requires:       perl(Mail::Sendmail)
Requires:       perl(HTML::Scrubber)
Requires:       perl(XML::Simple)
#Requires:  perl(CGI::FormBuilder)
Requires:  perl-CGI-FormBuilder
#Requires:  perl(CGI::Session)
Requires:  perl-CGI-Session
#Requires:  perl(File::MimeInfo)
Requires:  perl-File-MimeInfo

%define cgi_bin %{_libexecdir}/w3m/cgi-bin


%description
Ikiwiki is a wiki compiler. It converts wiki pages into HTML pages
suitable for publishing on a website. Ikiwiki stores pages and history
in a revision control system such as Subversion or Git. There are many
other features, including support for blogging, as well as a large
array of plugins.


%prep
%setup -q -n %{name}

# Filter unwanted Provides:
%{__cat} << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} $* |\
  %{__sed} -e '/perl(IkiWiki.*)/d'
EOF

%define __perl_provides %{_builddir}/%{name}/%{name}-prov
%{__chmod} +x %{__perl_provides}

# Filter Requires, all used by plugins
# - Monotone: see bz 450267
# - RPC::XML: see bz 435835
# - Net::Amazon:::S3: see bz 436481
%{__cat} << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
  %{__sed} -e '/perl(IkiWiki.*)/d' \
           -e '/perl(Monotone)/d' \
           -e '/perl(RPC::XML)/d' \
           -e '/perl(RPC::XML::Parser)/d' \
           -e '/perl(Net::Amazon::S3)/d'
EOF

%define __perl_requires %{_builddir}/%{name}/%{name}-req
%{__chmod} +x %{__perl_requires}

# goes into the -w3m subpackage
%{__cat} << \EOF > README.fedora
See http://ikiwiki.info/w3mmode/ for more information.
EOF


%build
%{__perl} Makefile.PL INSTALLDIRS=vendor PREFIX=%{_prefix}
# parallel builds currently don't work
%{__make} 


%install
%{__rm} -rf %{buildroot}
%{__make} pure_install DESTDIR=%{buildroot}
%find_lang %{name}

# cgi script is wrongly installed in a fixed place
%{__mkdir_p} %{buildroot}%{cgi_bin}
%{__mv} %{buildroot}/usr/lib/w3m/cgi-bin/ikiwiki-w3m.cgi \
        %{buildroot}%{cgi_bin}

# fix encoding
iconv -f iso-8859-9 -t utf-8 \
      html/tips/vim_syntax_highlighting/ikiwiki.vim \
      -o html/tips/vim_syntax_highlighting/ikiwiki.vim.tmp
%{__mv} html/tips/vim_syntax_highlighting/ikiwiki.vim.tmp \
        html/tips/vim_syntax_highlighting/ikiwiki.vim


%clean
%{__rm} -rf %{buildroot}


%files -f %{name}.lang
%defattr(-,root,root,-)
%{_bindir}/ikiwiki*
%{_sbindir}/ikiwiki*
%{_mandir}/man1/ikiwiki*
%{_mandir}/man8/ikiwiki*
%{_datadir}/ikiwiki
# contains a packlist only
%exclude %{perl_vendorarch}
%{perl_vendorlib}/IkiWiki*
# directory for external (non-perl) plugins, needs RPC::XML
%exclude %{_prefix}/lib/ikiwiki/plugins/*
%doc README debian/changelog debian/NEWS
%doc html

%package w3m
Summary:        Ikiwiki w3m cgi meta-wrapper
Group:          Applications/Internet
Requires:       w3m
Requires:       %{name} = %{version}-%{release}

%description w3m
Enable usage of all of ikiwiki's web features (page editing, etc) in
the w3m web browser without a web server. w3m supports local CGI
scripts, and ikiwiki can be set up to run that way using the
meta-wrapper in this package.


%files w3m
%defattr(-,root,root,-)
%doc README.fedora
%{cgi_bin}/ikiwiki-w3m.cgi


%changelog
* Sat Jul 12 2008 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.53-1m)
- update to 2.53

* Wed Jul  9 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.51-1m)
- import from Fedora to Momonga

* Sun Jul  6 2008 Thomas Moschny <thomas.moschny@gmx.de> - 2.51-1
- Update to 2.51.
- Save iconv output to a temporary file.

* Sun Jun 15 2008 Thomas Moschny <thomas.moschny@gmx.de> - 2.50-1
- Update to 2.50.
- Move ikiwiki-w3m.cgi into a subpackage.
- Add ikiwiki's own documentation.
- Remove duplicate requirement perl(File::MimeInfo).
- Minor cleanups.

* Mon Jun  2 2008 Thomas Moschny <thomas.moschny@gmx.de> - 2.48-1
- Update to 2.48.

* Wed May 28 2008 Thomas Moschny <thomas.moschny@gmx.de> - 2.47-1
- Update to 2.47.

* Tue May 13 2008 Thomas Moschny <thomas.moschny@gmx.de> - 2.46-1
- Update to 2.46.

* Sat May 10 2008 Thomas Moschny <thomas.moschny@gmx.de> - 2.45-1
- New package.
